Index: /LMDZ5/branches/testing/libf/phylmd/dyn1d/lmdz1d.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/dyn1d/lmdz1d.F90	(revision 2407)
+++ /LMDZ5/branches/testing/libf/phylmd/dyn1d/lmdz1d.F90	(revision 2408)
@@ -8,18 +8,32 @@
       PROGRAM lmdz1d
 
-      USE ioipsl, only: ju2ymds, ymds2ju, ioconf_calendar
-      use phys_state_var_mod
-      use dimphy
-      use surface_data, only : type_ocean,ok_veget
-      use pbl_surface_mod, only : ftsoil, pbl_surface_init,                     &
+   USE ioipsl, only: ju2ymds, ymds2ju, ioconf_calendar
+   USE phys_state_var_mod, ONLY : phys_state_var_init, phys_state_var_end, &
+       clwcon, detr_therm, &
+       qsol, fevap, z0m, z0h, agesno, &
+       du_gwd_rando, du_gwd_front, entr_therm, f0, fm_therm, &
+       falb_dir, falb_dif, &
+       ftsol, pbl_tke, pctsrf, radsol, rain_fall, snow_fall, ratqs, &
+       rlat, rlon, rnebcon, rugoro, sig1, w01, solaire_etat0, sollw, sollwdown, &
+       solsw, t_ancien, q_ancien, u_ancien, v_ancien, wake_cstar, wake_deltaq, &
+       wake_deltat, wake_delta_pbl_TKE, delta_tsurf, wake_fip, wake_pe, &
+       wake_s, zgam, &
+       zmax0, zmea, zpic, zsig, &
+       zstd, zthe, zval, ale_bl, ale_bl_trig, alp_bl
+   use dimphy
+   use surface_data, only : type_ocean,ok_veget
+   use pbl_surface_mod, only : ftsoil, pbl_surface_init,                     &
      &                            pbl_surface_final
       use fonte_neige_mod, only : fonte_neige_init, fonte_neige_final 
 
-      use infotrac ! new
-      use control_mod
-      USE indice_sol_mod
-      USE phyaqua_mod
-      USE mod_1D_cases_read
-      USE mod_1D_amma_read
+   use infotrac ! new
+   use control_mod
+   USE indice_sol_mod
+   USE phyaqua_mod
+   USE mod_1D_cases_read
+   USE mod_1D_amma_read
+   USE print_control_mod, ONLY: prt_level
+   USE iniphysiq_mod, ONLY: iniphysiq
+   USE mod_const_mpi, ONLY: comm_lmdz
 
       implicit none
@@ -28,5 +42,4 @@
 #include "temps.h"
 !!#include "control.h"
-#include "iniprint.h"
 #include "clesphys.h"
 #include "dimsoil.h"
@@ -36,4 +49,5 @@
 #include "compar1d.h"
 #include "flux_arp.h"
+#include "date_cas.h"
 #include "tsoilnudge.h"
 #include "fcg_gcssold.h"
@@ -124,5 +138,5 @@
 !vertical advection computation
 !       real d_t_z(llm), d_q_z(llm)
-!       real d_t_dyn_z(llm), d_q_dyn_z(llm)
+!       real d_t_dyn_z(llm), dq_dyn_z(llm)
 !       real zz(llm)
 !       real zfact
@@ -164,4 +178,5 @@
       real :: phi(llm)
       real :: teta(llm),tetal(llm),temp(llm),u(llm),v(llm),w(llm)
+      REAL rot(1, llm) ! relative vorticity, in s-1
       real :: rlat_rad(1),rlon_rad(1)
       real :: omega(llm+1),omega2(llm),rho(llm+1)
@@ -173,4 +188,5 @@
       real :: d_u_nudge(llm),d_v_nudge(llm)
       real :: du_adv(llm),dv_adv(llm)
+      real :: du_age(llm),dv_age(llm)
       real :: alpha
       real :: ttt
@@ -237,4 +253,18 @@
 ! INITIALIZATIONS 
 !=====================================================================
+      du_phys(:)=0.
+      dv_phys(:)=0.
+      dt_phys(:)=0.
+      dt_dyn(:)=0.
+      dt_cooling(:)=0.
+      d_th_adv(:)=0.
+      d_t_nudge(:)=0.
+      d_u_nudge(:)=0.
+      d_v_nudge(:)=0.
+      du_adv(:)=0.
+      dv_adv(:)=0.
+      du_age(:)=0.
+      dv_age(:)=0.
+      
 ! Initialization of Common turb_forcing
        dtime_frcg = 0.
@@ -284,7 +314,9 @@
 !             Different stages: soil model alone, atm. model alone
 !             then both models coupled
-!forcing_type = 10 ==> forcing_case = .true.
+!forcing_type >= 100 ==> forcing_case = .true.
 !             initial profiles and large scale forcings in cas.nc
 !             LS convergence, omega and SST imposed from CINDY-DYNAMO files 
+!             101=cindynamo
+!             102=bomex
 !forcing_type = 40 ==> forcing_GCSSold = .true.
 !             initial profile from GCSS file
@@ -323,6 +355,18 @@
       elseif (forcing_type .eq.7) THEN
        forcing_dice = .true.
-      elseif (forcing_type .eq.10) THEN
+      elseif (forcing_type .eq.101) THEN ! Cindynamo starts 1-10-2011 0h
        forcing_case = .true.
+       year_ini_cas=2011
+       mth_ini_cas=10
+       day_deb=1
+       heure_ini_cas=0.
+       pdt_cas=3*3600.         ! forcing frequency
+      elseif (forcing_type .eq.102) THEN ! Bomex starts 24-6-1969 0h
+       forcing_case = .true.
+       year_ini_cas=1969
+       mth_ini_cas=6
+       day_deb=24
+       heure_ini_cas=0.
+       pdt_cas=1800.         ! forcing frequency
       elseif (forcing_type .eq.40) THEN
        forcing_GCSSold = .true.
@@ -396,4 +440,5 @@
          fnday=-nday/float(day_step)
       endif
+      print *,'fnday=',fnday
 
 ! Special case for arm_cu which lasts less than one day : 53100s !! (MPL 20111026)
@@ -432,11 +477,12 @@
      & (year_ini_dice,mth_ini_dice,day_ini_dice,heure_ini_dice             & 
      & ,day_ju_ini_dice)
-      ELSEIF (forcing_type .eq.10) THEN
+      ELSEIF (forcing_type .gt.100) THEN
 ! Convert the initial date to Julian day
-      print*,'time cindy',year_ini_cas,mth_ini_cas,day_ini_cas
+      day_ini_cas=day_deb
+      print*,'time case',year_ini_cas,mth_ini_cas,day_ini_cas
       call ymds2ju                                                         &
-     & (year_ini_cas,mth_ini_cas,day_ini_cas,heure_ini_cas &
+     & (year_ini_cas,mth_ini_cas,day_ini_cas,heure_ini_cas              &
      & ,day_ju_ini_cas)
-      print*,'time cindy 2',day_ju_ini_cas
+      print*,'time case 2',day_ini_cas,day_ju_ini_cas
       ELSEIF (forcing_type .eq.59) THEN
 ! Convert the initial date of Sandu case to Julian day
@@ -467,5 +513,7 @@
 ! Initialization of dimensions, geometry and initial state
 !---------------------------------------------------------------------
-      call init_phys_lmdz(1,1,llm,1,(/1/))
+!      call init_phys_lmdz(1,1,llm,1,(/1/)) ! job now done via iniphysiq
+!     but we still need to initialize dimphy module (klon,klev,etc.)  here.
+      call init_dimphy(1,llm)
       call suphel
       call infotrac_init 
@@ -478,4 +526,10 @@
       allocate(d_q_nudge(llm,nqtot)) 
 !      allocate(d_th_adv(llm)) 
+
+      q(:,:) = 0.
+      dq(:,:) = 0.
+      dq_dyn(:,:) = 0.
+      d_q_adv(:,:) = 0.
+      d_q_nudge(:,:) = 0.
 
 !
@@ -540,8 +594,9 @@
 !       Dans ce cas, on lit ap,bp dans le fichier hybrid.txt
       ENDIF
+      ! initialize ap,bp, etc. in vertical_layers_mod
       sig_s=presnivs/preff
       plev =ap+bp*psurf
       play = 0.5*(plev(1:llm)+plev(2:llm+1))
-!cc      zlay=-rd*300.*log(play/psurf)/rg ! moved after reading profiles
+      zlay=-rd*300.*log(play/psurf)/rg ! moved after reading profiles
 
       IF (forcing_type .eq. 59) THEN
@@ -572,8 +627,8 @@
 
       print*,'mxcalc=',mxcalc
-      print*,'zlay=',zlay(mxcalc)
+!     print*,'zlay=',zlay(mxcalc)
       print*,'play=',play(mxcalc)
 
-!Al1 pour SST forced, appellé depuis ocean_forced_noice
+!Al1 pour SST forced, appell?? depuis ocean_forced_noice
       ts_cur = tsurf ! SST used in read_tsurf1d
 !=====================================================================
@@ -600,9 +655,19 @@
       zcvfi=airefi
 !
-      rlat_rad(:)=rlat(:)*rpi/180.
-      rlon_rad(:)=rlon(:)*rpi/180.
-
-      call iniphysiq(iim,jjm,llm,rday,day_ini,timestep,                        &
-     &     rlat_rad,rlon_rad,airefi,zcufi,zcvfi,ra,rg,rd,rcpd,(/1/))
+      rlat_rad(1)=rlat(1)*rpi/180.
+      rlon_rad(1)=rlon(1)*rpi/180.
+
+     ! Ehouarn: iniphysiq requires arrays related to (3D) dynamics grid,
+     ! e.g. for cell boundaries, which are meaningless in 1D; so pad these 
+     ! with '0.' when necessary
+      call iniphysiq(iim,jjm,llm, &
+           1,comm_lmdz, &
+           rday,day_ini,timestep,  &
+           (/rlat_rad(1),0./),(/0./), &
+           (/0.,0./),(/rlon_rad(1),0./),  &
+           (/ (/airefi,0./),(/0.,0./) /), &
+           (/zcufi,0.,0.,0./), &
+           (/zcvfi,0./), &
+           ra,rg,rd,rcpd,1)
       print*,'apres iniphysiq'
 
@@ -682,8 +747,10 @@
         solsw=0.
         sollw=0.
+        sollwdown=rsigma*tsurf**4
         radsol=0.
         rnebcon=0.
         ratqs=0.
         clwcon=0.
+        zmax0 = 0.
         zmea=0.
         zstd=0.
@@ -694,4 +761,21 @@
         sig1=0.
         w01=0.
+        wake_cstar = 0.
+        wake_deltaq = 0.
+        wake_deltat = 0.
+        wake_delta_pbl_TKE = 0.
+        delta_tsurf = 0.
+        wake_fip = 0.
+        wake_pe = 0.
+        wake_s = 0.
+        ale_bl = 0.
+        ale_bl_trig = 0.
+        alp_bl = 0.
+        IF (ALLOCATED(du_gwd_rando)) du_gwd_rando = 0.
+        IF (ALLOCATED(du_gwd_front)) du_gwd_front = 0.
+        entr_therm = 0.
+        detr_therm = 0.
+        f0 = 0.
+        fm_therm = 0.
         u_ancien(1,:)=u(:)
         v_ancien(1,:)=v(:)
@@ -704,5 +788,5 @@
 ! pctsrf(:,is_sic),ftsol(:,nsrf),tsoil(:,isoil,nsrf),qsurf(:,nsrf)
 ! qsol,falb_dir(:,nsrf),falb_dif(:,nsrf),evap(:,nsrf),snow(:,nsrf)
-! radsol,solsw,sollw,fder,rain_fall,snow_fall,frugs(:,nsrf)
+! radsol,solsw,sollw, sollwdown,fder,rain_fall,snow_fall,frugs(:,nsrf)
 ! agesno(:,nsrf),zmea,zstd,zsig,zgam,zthe,zpic,zval,rugoro
 ! t_ancien,q_ancien,,frugs(:,is_oce),clwcon(:,1),rnebcon(:,1),ratqs(:,1)
@@ -805,5 +889,5 @@
        if (prt_level.ge.1) then
          print*,'XXXXXXXXXXXXXXXXXXX ITAP,day,time=',                       &
-     &                                it,day,time,nint(fnday*day_step)
+     &             it,day,time,nint(fnday*day_step),day_step
          print*,'PAS DE TEMPS ',timestep
        endif
@@ -853,11 +937,10 @@
 !---------------------------------------------------------------------
 
-        call physiq(ngrid,llm,                                              &
-     &              firstcall,lastcall,                                     &
-     &              day,time,timestep,                                      &
-     &              plev,play,phi,phis,presnivs,                            &
-     &              u,v,temp,q,omega2,                                      &
-     &              du_phys,dv_phys,dt_phys,dq,dpsrf,                        &
-     &              dudyn)
+       call physiq(ngrid,llm, &
+            firstcall,lastcall, day,time,timestep, &
+            plev,play,phi,phis,presnivs, &
+            u,v, rot, temp,q,omega2, &
+            du_phys,dv_phys,dt_phys,dq,dpsrf, &
+            dudyn)
         firstcall=.false.
 
@@ -892,4 +975,5 @@
          d_q_adv=0.0
        endif
+!      print*, 'calcul de fcoriolis ', fcoriolis
 
        if (forcing_toga .or. forcing_GCSSold .or. forcing_twpice            &
@@ -901,8 +985,10 @@
         endif
 
-      print*, 'fcoriolis ', fcoriolis, xlat
-
-        du_age(1:mxcalc)=fcoriolis*(v(1:mxcalc)-vg(1:mxcalc))
+      IF (prt_level >= 1) print*, 'fcoriolis, xlat,mxcalc ', &
+                                   fcoriolis, xlat,mxcalc
+
+       du_age(1:mxcalc)=fcoriolis*(v(1:mxcalc)-vg(1:mxcalc))
        dv_age(1:mxcalc)=-fcoriolis*(u(1:mxcalc)-ug(1:mxcalc))
+!       print *,'u-ug=',u-ug
 
 !!!!!!!!!!!!!!!!!!!!!!!!
@@ -911,4 +997,5 @@
        sfdt = sin(0.5*fcoriolis*timestep)
        cfdt = cos(0.5*fcoriolis*timestep)
+!       print *,'fcoriolis,sfdt,cfdt,timestep',fcoriolis,sfdt,cfdt,timestep
 !
         du_age(1:mxcalc)= -2.*sfdt/timestep*                                &
@@ -970,5 +1057,8 @@
      &    'physiq-> temp(1),dt_phys(1),d_th_adv(1),dt_cooling(1) ',         &
      &              temp(1),dt_phys(1),d_th_adv(1),dt_cooling(1)
-           print*,du_phys
+           print* ,'dv_phys=',dv_phys
+           print* ,'dv_age=',dv_age
+           print* ,'dv_adv=',dv_adv
+           print* ,'d_v_nudge=',d_v_nudge
            print*, v
            print*, vg
Index: /LMDZ5/branches/testing/libf/phylmd/dyn1d/mod_1D_amma_read.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/dyn1d/mod_1D_amma_read.F90	(revision 2408)
+++ /LMDZ5/branches/testing/libf/phylmd/dyn1d/mod_1D_amma_read.F90	(revision 2408)
@@ -0,0 +1,504 @@
+MODULE mod_1D_amma_read
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!Declarations specifiques au cas AMMA
+        character*80 :: fich_amma
+! Option du cas AMMA ou on impose la discretisation verticale (Ap,Bp)
+        integer nlev_amma, nt_amma
+
+
+        integer year_ini_amma, day_ini_amma, mth_ini_amma
+        real heure_ini_amma
+        real day_ju_ini_amma   ! Julian day of amma first day
+        parameter (year_ini_amma=2006)
+        parameter (mth_ini_amma=7)
+        parameter (day_ini_amma=10)  ! 10 = 10Juil2006
+        parameter (heure_ini_amma=0.) !0h en secondes
+        real dt_amma
+        parameter (dt_amma=1800.)
+
+!profils initiaux:
+        real, allocatable::  plev_amma(:)
+
+        real, allocatable::  z_amma(:)
+        real, allocatable::  th_amma(:),q_amma(:)
+        real, allocatable::  u_amma(:)
+        real, allocatable::  v_amma(:)
+
+        real, allocatable::  th_ammai(:),q_ammai(:)
+        real, allocatable::  u_ammai(:)
+        real, allocatable::  v_ammai(:)
+        real, allocatable::  vitw_ammai(:)
+        real, allocatable::  ht_ammai(:)
+        real, allocatable::  hq_ammai(:)
+        real, allocatable::  vt_ammai(:)
+        real, allocatable::  vq_ammai(:)
+
+!forcings
+        real, allocatable::  ht_amma(:,:)
+        real, allocatable::  hq_amma(:,:)
+        real, allocatable::  vitw_amma(:,:)
+        real, allocatable::  lat_amma(:),sens_amma(:)
+
+!champs interpoles
+        real, allocatable::  vitw_profamma(:)
+        real, allocatable::  ht_profamma(:)
+        real, allocatable::  hq_profamma(:)
+        real lat_profamma,sens_profamma
+        real, allocatable::  vt_profamma(:)
+        real, allocatable::  vq_profamma(:)
+        real, allocatable::  th_profamma(:)
+        real, allocatable::  q_profamma(:)
+        real, allocatable::  u_profamma(:)
+        real, allocatable::  v_profamma(:)
+
+
+CONTAINS
+
+SUBROUTINE read_1D_cases
+      implicit none
+
+#include "netcdf.inc"
+
+      INTEGER nid,rid,ierr
+
+      fich_amma='amma.nc'
+      print*,'fich_amma ',fich_amma
+      ierr = NF_OPEN(fich_amma,NF_NOWRITE,nid)
+      print*,'fich_amma,NF_NOWRITE,nid ',fich_amma,NF_NOWRITE,nid
+      if (ierr.NE.NF_NOERR) then
+         write(*,*) 'ERROR: GROS Pb opening forcings nc file '
+         write(*,*) NF_STRERROR(ierr)
+         stop ""
+      endif
+!.......................................................................
+      ierr=NF_INQ_DIMID(nid,'lev',rid)
+      IF (ierr.NE.NF_NOERR) THEN
+         print*, 'Oh probleme lecture dimension zz'
+      ENDIF
+      ierr=NF_INQ_DIMLEN(nid,rid,nlev_amma)
+      print*,'OK nid,rid,nlev_amma',nid,rid,nlev_amma
+!.......................................................................
+      ierr=NF_INQ_DIMID(nid,'time',rid)
+      print*,'nid,rid',nid,rid
+      nt_amma=0
+      IF (ierr.NE.NF_NOERR) THEN
+        stop 'probleme lecture dimension sens'
+      ENDIF
+      ierr=NF_INQ_DIMLEN(nid,rid,nt_amma)
+      print*,'nid,rid,nlev_amma',nid,rid,nt_amma
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!profils initiaux:
+        allocate(plev_amma(nlev_amma))
+        
+        allocate(z_amma(nlev_amma))
+        allocate(th_amma(nlev_amma),q_amma(nlev_amma))
+        allocate(u_amma(nlev_amma))
+        allocate(v_amma(nlev_amma))
+
+!forcings
+        allocate(ht_amma(nlev_amma,nt_amma))
+        allocate(hq_amma(nlev_amma,nt_amma))
+        allocate(vitw_amma(nlev_amma,nt_amma))
+        allocate(lat_amma(nt_amma),sens_amma(nt_amma))
+
+!profils initiaux:
+        allocate(th_ammai(nlev_amma),q_ammai(nlev_amma))
+        allocate(u_ammai(nlev_amma))
+        allocate(v_ammai(nlev_amma))
+        allocate(vitw_ammai(nlev_amma) )
+        allocate(ht_ammai(nlev_amma))
+        allocate(hq_ammai(nlev_amma))
+        allocate(vt_ammai(nlev_amma))
+        allocate(vq_ammai(nlev_amma))
+
+!champs interpoles
+        allocate(vitw_profamma(nlev_amma))
+        allocate(ht_profamma(nlev_amma))
+        allocate(hq_profamma(nlev_amma))
+        allocate(vt_profamma(nlev_amma))
+        allocate(vq_profamma(nlev_amma))
+        allocate(th_profamma(nlev_amma))
+        allocate(q_profamma(nlev_amma))
+        allocate(u_profamma(nlev_amma))
+        allocate(v_profamma(nlev_amma))
+
+        print*,'Allocations OK'
+        call read_amma(nid,nlev_amma,nt_amma                                  &
+     &     ,z_amma,plev_amma,th_amma,q_amma,u_amma,v_amma,vitw_amma         &
+     &     ,ht_amma,hq_amma,sens_amma,lat_amma)
+
+END SUBROUTINE read_1D_cases
+
+
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+SUBROUTINE deallocate_1D_cases
+!profils initiaux:
+        deallocate(plev_amma)
+        
+        deallocate(z_amma)
+        deallocate(th_amma,q_amma)
+        deallocate(u_amma)
+        deallocate(v_amma)
+
+        deallocate(th_ammai,q_ammai)
+        deallocate(u_ammai)
+        deallocate(v_ammai)
+        deallocate(vitw_ammai )
+        deallocate(ht_ammai)
+        deallocate(hq_ammai)
+        deallocate(vt_ammai)
+        deallocate(vq_ammai)
+        
+!forcings
+        deallocate(ht_amma)
+        deallocate(hq_amma)
+        deallocate(vitw_amma)
+        deallocate(lat_amma,sens_amma)
+
+!champs interpoles
+        deallocate(vitw_profamma)
+        deallocate(ht_profamma)
+        deallocate(hq_profamma)
+        deallocate(vt_profamma)
+        deallocate(vq_profamma)
+        deallocate(th_profamma)
+        deallocate(q_profamma)
+        deallocate(u_profamma)
+        deallocate(v_profamma)
+END SUBROUTINE deallocate_1D_cases
+
+
+END MODULE mod_1D_amma_read
+!=====================================================================
+      subroutine read_amma(nid,nlevel,ntime                          &
+     &     ,zz,pp,temp,qv,u,v,dw                   &
+     &     ,dt,dq,sens,flat)
+
+!program reading forcings of the AMMA case study
+      implicit none
+#include "netcdf.inc"
+
+      integer ntime,nlevel
+
+      real zz(nlevel)
+      real temp(nlevel),pp(nlevel)
+      real qv(nlevel),u(nlevel)
+      real v(nlevel)
+      real dw(nlevel,ntime)
+      real dt(nlevel,ntime)
+      real dq(nlevel,ntime)
+      real flat(ntime),sens(ntime)
+
+
+      integer nid, ierr,rid
+      integer nbvar3d
+      parameter(nbvar3d=30)
+      integer var3didin(nbvar3d)
+
+       ierr=NF_INQ_VARID(nid,"zz",var3didin(1)) 
+         if(ierr/=NF_NOERR) then
+           write(*,*) NF_STRERROR(ierr)
+           stop 'lev'
+         endif
+
+
+      ierr=NF_INQ_VARID(nid,"temp",var3didin(2))
+         if(ierr/=NF_NOERR) then
+           write(*,*) NF_STRERROR(ierr)
+           stop 'temp'
+         endif
+
+      ierr=NF_INQ_VARID(nid,"qv",var3didin(3))
+         if(ierr/=NF_NOERR) then
+           write(*,*) NF_STRERROR(ierr)
+           stop 'qv'
+         endif
+
+      ierr=NF_INQ_VARID(nid,"u",var3didin(4))
+         if(ierr/=NF_NOERR) then
+           write(*,*) NF_STRERROR(ierr)
+           stop 'u'
+         endif
+
+      ierr=NF_INQ_VARID(nid,"v",var3didin(5))
+         if(ierr/=NF_NOERR) then
+           write(*,*) NF_STRERROR(ierr)
+           stop 'v'
+         endif
+
+      ierr=NF_INQ_VARID(nid,"dw",var3didin(6))
+         if(ierr/=NF_NOERR) then
+           write(*,*) NF_STRERROR(ierr)
+           stop 'dw'
+         endif
+
+      ierr=NF_INQ_VARID(nid,"dt",var3didin(7))
+         if(ierr/=NF_NOERR) then
+           write(*,*) NF_STRERROR(ierr)
+           stop 'dt'
+         endif
+
+      ierr=NF_INQ_VARID(nid,"dq",var3didin(8))
+         if(ierr/=NF_NOERR) then
+           write(*,*) NF_STRERROR(ierr)
+           stop 'dq'
+         endif
+      
+      ierr=NF_INQ_VARID(nid,"sens",var3didin(9))
+         if(ierr/=NF_NOERR) then
+           write(*,*) NF_STRERROR(ierr)
+           stop 'sens'
+         endif
+
+      ierr=NF_INQ_VARID(nid,"flat",var3didin(10))
+         if(ierr/=NF_NOERR) then
+           write(*,*) NF_STRERROR(ierr)
+           stop 'flat'
+         endif
+
+      ierr=NF_INQ_VARID(nid,"pp",var3didin(11))
+         if(ierr/=NF_NOERR) then
+           write(*,*) NF_STRERROR(ierr)
+      endif
+
+!dimensions lecture
+!      call catchaxis(nid,ntime,nlevel,time,z,ierr)
+ 
+#ifdef NC_DOUBLE
+         ierr = NF_GET_VAR_DOUBLE(nid,var3didin(1),zz)
+#else
+         ierr = NF_GET_VAR_REAL(nid,var3didin(1),zz)
+#endif
+         if(ierr/=NF_NOERR) then
+            write(*,*) NF_STRERROR(ierr)
+            stop "getvarup"
+         endif
+!          write(*,*)'lecture z ok',zz
+
+#ifdef NC_DOUBLE
+         ierr = NF_GET_VAR_DOUBLE(nid,var3didin(2),temp)
+#else
+         ierr = NF_GET_VAR_REAL(nid,var3didin(2),temp)
+#endif
+         if(ierr/=NF_NOERR) then
+            write(*,*) NF_STRERROR(ierr)
+            stop "getvarup"
+         endif
+!          write(*,*)'lecture th ok',temp
+
+#ifdef NC_DOUBLE
+         ierr = NF_GET_VAR_DOUBLE(nid,var3didin(3),qv)
+#else
+         ierr = NF_GET_VAR_REAL(nid,var3didin(3),qv)
+#endif
+         if(ierr/=NF_NOERR) then
+            write(*,*) NF_STRERROR(ierr)
+            stop "getvarup"
+         endif
+!          write(*,*)'lecture qv ok',qv
+ 
+#ifdef NC_DOUBLE
+         ierr = NF_GET_VAR_DOUBLE(nid,var3didin(4),u)
+#else
+         ierr = NF_GET_VAR_REAL(nid,var3didin(4),u)
+#endif
+         if(ierr/=NF_NOERR) then
+            write(*,*) NF_STRERROR(ierr)
+            stop "getvarup"
+         endif
+!          write(*,*)'lecture u ok',u
+
+#ifdef NC_DOUBLE
+         ierr = NF_GET_VAR_DOUBLE(nid,var3didin(5),v)
+#else
+         ierr = NF_GET_VAR_REAL(nid,var3didin(5),v)
+#endif
+         if(ierr/=NF_NOERR) then
+            write(*,*) NF_STRERROR(ierr)
+            stop "getvarup"
+         endif
+!          write(*,*)'lecture v ok',v
+
+#ifdef NC_DOUBLE
+         ierr = NF_GET_VAR_DOUBLE(nid,var3didin(6),dw)
+#else
+         ierr = NF_GET_VAR_REAL(nid,var3didin(6),dw)
+#endif
+         if(ierr/=NF_NOERR) then
+            write(*,*) NF_STRERROR(ierr)
+            stop "getvarup"
+         endif
+!          write(*,*)'lecture w ok',dw
+
+#ifdef NC_DOUBLE
+         ierr = NF_GET_VAR_DOUBLE(nid,var3didin(7),dt)
+#else
+         ierr = NF_GET_VAR_REAL(nid,var3didin(7),dt)
+#endif
+         if(ierr/=NF_NOERR) then
+            write(*,*) NF_STRERROR(ierr)
+            stop "getvarup"
+         endif
+!          write(*,*)'lecture dt ok',dt
+
+#ifdef NC_DOUBLE
+         ierr = NF_GET_VAR_DOUBLE(nid,var3didin(8),dq)
+#else
+         ierr = NF_GET_VAR_REAL(nid,var3didin(8),dq)
+#endif
+         if(ierr/=NF_NOERR) then
+            write(*,*) NF_STRERROR(ierr)
+            stop "getvarup"
+         endif
+!          write(*,*)'lecture dq ok',dq
+
+#ifdef NC_DOUBLE
+         ierr = NF_GET_VAR_DOUBLE(nid,var3didin(9),sens)
+#else
+         ierr = NF_GET_VAR_REAL(nid,var3didin(9),sens)
+#endif
+         if(ierr/=NF_NOERR) then
+            write(*,*) NF_STRERROR(ierr)
+            stop "getvarup"
+         endif
+!          write(*,*)'lecture sens ok',sens
+
+#ifdef NC_DOUBLE
+         ierr = NF_GET_VAR_DOUBLE(nid,var3didin(10),flat)
+#else
+         ierr = NF_GET_VAR_REAL(nid,var3didin(10),flat)
+#endif
+         if(ierr/=NF_NOERR) then
+            write(*,*) NF_STRERROR(ierr)
+            stop "getvarup"
+         endif
+!          write(*,*)'lecture flat ok',flat
+
+#ifdef NC_DOUBLE
+         ierr = NF_GET_VAR_DOUBLE(nid,var3didin(11),pp)
+#else
+         ierr = NF_GET_VAR_REAL(nid,var3didin(11),pp)
+#endif
+         if(ierr/=NF_NOERR) then
+            write(*,*) NF_STRERROR(ierr)
+            stop "getvarup"
+         endif
+!          write(*,*)'lecture pp ok',pp
+
+         return 
+         end subroutine read_amma
+!======================================================================
+        SUBROUTINE interp_amma_time(day,day1,annee_ref                     &
+     &         ,year_ini_amma,day_ini_amma,nt_amma,dt_amma,nlev_amma       &
+     &         ,vitw_amma,ht_amma,hq_amma,lat_amma,sens_amma               &
+     &         ,vitw_prof,ht_prof,hq_prof,lat_prof,sens_prof)
+        implicit none
+
+!---------------------------------------------------------------------------------------
+! Time interpolation of a 2D field to the timestep corresponding to day
+!
+! day: current julian day (e.g. 717538.2)
+! day1: first day of the simulation
+! nt_amma: total nb of data in the forcing (e.g. 48 for AMMA)
+! dt_amma: total time interval (in sec) between 2 forcing data (e.g. 30min for AMMA)
+!---------------------------------------------------------------------------------------
+
+#include "compar1d.h"
+
+! inputs:
+        integer annee_ref
+        integer nt_amma,nlev_amma
+        integer year_ini_amma
+        real day, day1,day_ini_amma,dt_amma
+        real vitw_amma(nlev_amma,nt_amma)
+        real ht_amma(nlev_amma,nt_amma)
+        real hq_amma(nlev_amma,nt_amma)
+        real lat_amma(nt_amma)
+        real sens_amma(nt_amma)
+! outputs:
+        real vitw_prof(nlev_amma)
+        real ht_prof(nlev_amma)
+        real hq_prof(nlev_amma)
+        real lat_prof,sens_prof
+! local:
+        integer it_amma1, it_amma2,k
+        real timeit,time_amma1,time_amma2,frac
+
+
+        if (forcing_type.eq.6) then
+! Check that initial day of the simulation consistent with AMMA case:
+       if (annee_ref.ne.2006) then
+        print*,'Pour AMMA, annee_ref doit etre 2006'
+        print*,'Changer annee_ref dans run.def'
+        stop
+       endif
+       if (annee_ref.eq.2006 .and. day1.lt.day_ini_amma) then
+        print*,'AMMA a débuté le 10 juillet 2006',day1,day_ini_amma
+        print*,'Changer dayref dans run.def'
+        stop
+       endif
+       if (annee_ref.eq.2006 .and. day1.gt.day_ini_amma+1) then
+        print*,'AMMA a fini le 11 juillet'
+        print*,'Changer dayref ou nday dans run.def'
+        stop
+       endif
+       endif
+
+! Determine timestep relative to the 1st day of AMMA:
+!       timeit=(day-day1)*86400.
+!       if (annee_ref.eq.1992) then
+!        timeit=(day-day_ini_toga)*86400.
+!       else
+!        timeit=(day+61.-1.)*86400. ! 61 days between Nov01 and Dec31 1992
+!       endif
+      timeit=(day-day_ini_amma)*86400
+
+! Determine the closest observation times:
+!       it_amma1=INT(timeit/dt_amma)+1
+!       it_amma2=it_amma1 + 1
+!       time_amma1=(it_amma1-1)*dt_amma
+!       time_amma2=(it_amma2-1)*dt_amma
+
+       it_amma1=INT(timeit/dt_amma)+1
+       IF (it_amma1 .EQ. nt_amma) THEN
+       it_amma2=it_amma1 
+       ELSE
+       it_amma2=it_amma1 + 1
+       ENDIF
+       time_amma1=(it_amma1-1)*dt_amma
+       time_amma2=(it_amma2-1)*dt_amma
+
+       if (it_amma1 .gt. nt_amma) then
+        write(*,*) 'PB-stop: day, it_amma1, it_amma2, timeit: '            &
+     &        ,day,day_ini_amma,it_amma1,it_amma2,timeit/86400.
+        stop
+       endif
+
+! time interpolation:
+       IF (it_amma1 .EQ. it_amma2) THEN
+          frac=0.
+       ELSE 
+          frac=(time_amma2-timeit)/(time_amma2-time_amma1)
+          frac=max(frac,0.0)
+       ENDIF
+
+       lat_prof = lat_amma(it_amma2)                                       &
+     &          -frac*(lat_amma(it_amma2)-lat_amma(it_amma1)) 
+       sens_prof = sens_amma(it_amma2)                                     &
+     &          -frac*(sens_amma(it_amma2)-sens_amma(it_amma1))
+
+       do k=1,nlev_amma
+        vitw_prof(k) = vitw_amma(k,it_amma2)                               &
+     &          -frac*(vitw_amma(k,it_amma2)-vitw_amma(k,it_amma1))
+        ht_prof(k) = ht_amma(k,it_amma2)                                   &
+     &          -frac*(ht_amma(k,it_amma2)-ht_amma(k,it_amma1))
+        hq_prof(k) = hq_amma(k,it_amma2)                                   &
+     &          -frac*(hq_amma(k,it_amma2)-hq_amma(k,it_amma1))
+        enddo
+
+        return
+        END
+
